Index: trunk/src/org/openstreetmap/josm/gui/io/FlagCellEditor.java
===================================================================
--- trunk/src/org/openstreetmap/josm/gui/io/FlagCellEditor.java	(revision 2025)
+++ trunk/src/org/openstreetmap/josm/gui/io/FlagCellEditor.java	(revision 2025)
@@ -0,0 +1,97 @@
+// License: GPL. For details, see LICENSE file.
+package org.openstreetmap.josm.gui.io;
+
+import java.awt.Component;
+import java.awt.event.MouseAdapter;
+import java.awt.event.MouseEvent;
+import java.util.EventObject;
+import java.util.concurrent.CopyOnWriteArrayList;
+
+import javax.swing.JCheckBox;
+import javax.swing.JTable;
+import javax.swing.event.CellEditorListener;
+import javax.swing.event.ChangeEvent;
+import javax.swing.table.TableCellEditor;
+
+/**
+ * This is {@see TableCellEditor} for a boolean flag. It is used in two table columns of
+ * {@see SaveLayersTable} and renders the values of {@see SaveLayerInfo#isDoSaveToFile()}
+ * and {@see SaveLayerInfo#isDoUploadToServer()}
+ * 
+ */
+class SaveFlagCellEditor extends JCheckBox implements TableCellEditor {
+    private CopyOnWriteArrayList<CellEditorListener> listeners;
+    private boolean value;
+
+    public SaveFlagCellEditor() {
+        listeners = new CopyOnWriteArrayList<CellEditorListener>();
+        addMouseListener(
+                new MouseAdapter() {
+                    @Override
+                    public void mouseExited(MouseEvent e) {
+                        stopCellEditing();
+                    }
+                }
+        );
+    }
+
+    public void addCellEditorListener(CellEditorListener l) {
+        if (!listeners.contains(l)) {
+            listeners.add(l);
+        }
+    }
+
+    protected void fireEditingCanceled() {
+        for (CellEditorListener l: listeners) {
+            l.editingCanceled(new ChangeEvent(this));
+        }
+    }
+
+    protected void fireEditingStopped() {
+        for (CellEditorListener l: listeners) {
+            l.editingStopped(new ChangeEvent(this));
+        }
+    }
+
+    public void cancelCellEditing() {
+        fireEditingCanceled();
+    }
+
+    public Object getCellEditorValue() {
+        return value;
+    }
+
+    public boolean isCellEditable(EventObject anEvent) {
+        return true;
+    }
+
+    public void removeCellEditorListener(CellEditorListener l) {
+        if (listeners.contains(l)) {
+            listeners.remove(l);
+        }
+    }
+
+    public boolean shouldSelectCell(EventObject anEvent) {
+        return true;
+    }
+
+    public void setInitialValue(boolean value) {
+        this.value = value;
+        setSelected(value);
+    }
+
+    public boolean stopCellEditing() {
+        this.value = isSelected();
+        fireEditingStopped();
+        return true;
+    }
+
+    public Component getTableCellEditorComponent(JTable table, Object value, boolean isSelected, int row, int column) {
+        SaveLayerInfo info = (SaveLayerInfo)value;
+        switch(column) {
+            case 4: setInitialValue(info.isDoUploadToServer()); break;
+            case 5: setInitialValue(info.isDoSaveToFile()); break;
+        }
+        return this;
+    }
+}
Index: trunk/src/org/openstreetmap/josm/gui/io/SaveLayerInfo.java
===================================================================
--- trunk/src/org/openstreetmap/josm/gui/io/SaveLayerInfo.java	(revision 2025)
+++ trunk/src/org/openstreetmap/josm/gui/io/SaveLayerInfo.java	(revision 2025)
@@ -0,0 +1,200 @@
+// License: GPL. For details, see LICENSE file.
+package org.openstreetmap.josm.gui.io;
+
+import java.io.File;
+
+import org.openstreetmap.josm.gui.layer.OsmDataLayer;
+import static org.openstreetmap.josm.tools.I18n.tr;
+
+/**
+ * SaveLayerInfo represents the information, user preferences and save/upload states of
+ * a layer which might be uploaded/saved.
+ * 
+ */
+class SaveLayerInfo implements Comparable<SaveLayerInfo> {
+
+    /** the osm data layer */
+    private OsmDataLayer layer;
+    private boolean doSaveToFile;
+    private boolean doUploadToServer;
+    private File file;
+    private UploadOrSaveState uploadState;
+    private UploadOrSaveState saveState;
+
+    /**
+     * 
+     * @param layer the layer. Must not be null.
+     * @throws IllegalArgumentException thrown if layer is null
+     */
+    public SaveLayerInfo(OsmDataLayer layer) {
+        if (layer == null)
+            throw new IllegalArgumentException(tr("parameter ''{0}'' must not be null", "layer"));
+        this.layer = layer;
+        this.doSaveToFile = layer.requiresSaveToFile();
+        this.doUploadToServer = layer.requiresUploadToServer();
+        this.file = layer.getAssociatedFile();
+    }
+
+    /**
+     * Replies the layer this info objects holds information for
+     * 
+     * @return the layer this info objects holds information for
+     */
+    public OsmDataLayer getLayer() {
+        return layer;
+    }
+
+    /**
+     * Replies true if this layer should be saved to a file; false, otherwise
+     * 
+     * @return true if this layers should be saved to a file; false, otherwise
+     */
+    public boolean isDoSaveToFile() {
+        return doSaveToFile;
+    }
+
+    /**
+     * Sets whether this layer should be saved to a file
+     * 
+     * @param doSaveToFile true to save; false, to skip saving
+     */
+    public void setDoSaveToFile(boolean doSaveToFile) {
+        this.doSaveToFile = doSaveToFile;
+    }
+
+    /**
+     * Replies true if this layer should be uploaded to the server; false, otherwise
+     * 
+     * @return true if this layer should be uploaded to the server; false, otherwise
+     */
+    public boolean isDoUploadToServer() {
+        return doUploadToServer;
+    }
+
+    /**
+     * Sets whether this layer should be uploaded to a file
+     * 
+     * @param doSaveToFile true to upload; false, to skip uploading
+     */
+
+    public void setDoUploadToServer(boolean doUploadToServer) {
+        this.doUploadToServer = doUploadToServer;
+    }
+
+    /**
+     * Replies true if this layer should be uploaded to the server and saved to file.
+     * 
+     * @return true if this layer should be uploaded to the server and saved to file
+     */
+    public boolean isDoSaveAndUpload() {
+        return isDoSaveToFile() && isDoUploadToServer();
+    }
+
+    /**
+     * Replies the name of the layer
+     * 
+     * @return the name of the layer
+     */
+    public String getName() {
+        return layer.getName() == null ? "" : layer.getName();
+    }
+
+    /**
+     * Replies the file this layer should be saved to, if {@see #isDoSaveToFile()} is true
+     * 
+     * @return the file this layer should be saved to, if {@see #isDoSaveToFile()} is true
+     */
+    public File getFile() {
+        return file;
+    }
+
+    /**
+     * Sets the file this layer should be saved to, if {@see #isDoSaveToFile()} is true
+     * 
+     * @param file the file
+     */
+    public void setFile(File file) {
+        this.file = file;
+    }
+
+    public int compareTo(SaveLayerInfo o) {
+        if (isDoSaveAndUpload()) {
+            if (o.isDoSaveAndUpload())
+                return getName().compareTo(o.getName());
+            return -1;
+        } else if (o.isDoSaveAndUpload())
+            return 1;
+        if (isDoUploadToServer()) {
+            if (o.isDoUploadToServer())
+                return getName().compareTo(o.getName());
+            return -1;
+        } else if (o.isDoUploadToServer())
+            return 1;
+        if (isDoSaveToFile()) {
+            if (o.isDoSaveToFile())
+                return getName().compareTo(o.getName());
+            return -1;
+        } else if (o.isDoSaveToFile())
+            return 1;
+        return getName().compareTo(o.getName());
+    }
+
+    /**
+     * Replies the upload state of {@see #getLayer()}.
+     * <ul>
+     *   <li>{@see UploadOrSaveState#OK} if {@see #getLayer() was successfully uploaded</li>
+     *   <li>{@see UploadOrSaveState#CANCELLED} if uploading {@see #getLayer() was cancelled</li>
+     *   <li>{@see UploadOrSaveState#FAILED} if uploading {@see #getLayer() has failed</li>
+     * </ul>
+     * 
+     * @return the upload state
+     */
+    public UploadOrSaveState getUploadState() {
+        return uploadState;
+    }
+
+    /**
+     * Sets the upload state for {@see #getLayer()}
+     * 
+     * @param uploadState the upload state
+     */
+    public void setUploadState(UploadOrSaveState uploadState) {
+        this.uploadState = uploadState;
+    }
+
+    /**
+     * Replies the save state of {@see #getLayer()}.
+     * <ul>
+     *   <li>{@see UploadOrSaveState#OK} if {@see #getLayer() was successfully saved to file</li>
+     *   <li>{@see UploadOrSaveState#CANCELLED} if saving {@see #getLayer() was cancelled</li>
+     *   <li>{@see UploadOrSaveState#FAILED} if saving {@see #getLayer() has failed</li>
+     * </ul>
+     * 
+     * @return the save state
+     */
+    public UploadOrSaveState getSaveState() {
+        return saveState;
+    }
+
+    /**
+     * Sets the save state for {@see #getLayer()}
+     * 
+     * @param saveState save the upload state
+     */
+    public void setSaveState(UploadOrSaveState saveState) {
+        this.saveState = saveState;
+    }
+
+    /**
+     * Resets the upload and save state
+     * 
+     * @see #setUploadState(UploadOrSaveState)
+     * @see #setSaveState(UploadOrSaveState)
+     * @see #getUploadState()
+     * @see #getSaveState()
+     */
+    public void resetUploadAndSaveState() {
+        this.uploadState = null;
+        this.saveState = null;
+    }
+}
Index: trunk/src/org/openstreetmap/josm/gui/io/SaveLayerInfoCellRenderer.java
===================================================================
--- trunk/src/org/openstreetmap/josm/gui/io/SaveLayerInfoCellRenderer.java	(revision 2025)
+++ trunk/src/org/openstreetmap/josm/gui/io/SaveLayerInfoCellRenderer.java	(revision 2025)
@@ -0,0 +1,148 @@
+// License: GPL. For details, see LICENSE file.
+package org.openstreetmap.josm.gui.io;
+
+import static org.openstreetmap.josm.tools.I18n.tr;
+
+import java.awt.Color;
+import java.awt.Component;
+import java.awt.Font;
+import java.io.File;
+import java.io.IOException;
+
+import javax.swing.JCheckBox;
+import javax.swing.JLabel;
+import javax.swing.JTable;
+import javax.swing.UIManager;
+import javax.swing.table.TableCellRenderer;
+
+import org.openstreetmap.josm.io.OsmApi;
+
+/**
+ * This is a {@see TableCellRenderer} for rendering the various fields of a
+ * {@see SaveLayerInfo} in the table {@see SaveLayersTable}.
+ * 
+ *
+ */
+class SaveLayerInfoCellRenderer implements TableCellRenderer {
+    private JLabel lblRenderer;
+    private JCheckBox cbRenderer;
+
+    public SaveLayerInfoCellRenderer() {
+        lblRenderer = new JLabel();
+        cbRenderer = new JCheckBox();
+    }
+
+    protected Component prepareLayerNameRenderer(SaveLayerInfo info) {
+        lblRenderer.setIcon(info.getLayer().getIcon());
+        lblRenderer.setText(info.getName());
+        lblRenderer.setToolTipText(info.getLayer().getToolTipText());
+        return lblRenderer;
+    }
+
+    protected Component prepareUploadRequiredRenderer(SaveLayerInfo info) {
+        lblRenderer.setIcon(null);
+        lblRenderer.setHorizontalAlignment(JLabel.CENTER);
+        String text = info.getLayer().requiresUploadToServer() ? tr("Yes") : tr("No");
+        lblRenderer.setText(text);
+        if (info.getLayer().requiresUploadToServer()) {
+            lblRenderer.setToolTipText(tr("Layer ''{0}'' has modifications which should be uploaded to the server.", info.getName()));
+        } else {
+            lblRenderer.setToolTipText(tr("Layer ''{0}'' has no modifications to be uploaded", info.getName()));
+        }
+        return lblRenderer;
+    }
+
+    protected Component prepareSaveToFileRequired(SaveLayerInfo info) {
+        lblRenderer.setIcon(null);
+        lblRenderer.setHorizontalAlignment(JLabel.CENTER);
+        String text = info.getLayer().requiresSaveToFile() ? tr("Yes") : tr("No");
+        lblRenderer.setText(text);
+        if (info.getLayer().requiresSaveToFile()) {
+            lblRenderer.setToolTipText(tr("Layer ''{0}'' has modifications which should be saved to its assoicated file ''{1}''.", info.getName(), info.getFile().toString()));
+        } else {
+            lblRenderer.setToolTipText(tr("Layer ''{0}'' has no modifications to be saved", info.getName()));
+        }
+        return lblRenderer;
+    }
+
+    protected boolean canWrite(File f) {
+        if (f == null) return false;
+        if (f.isDirectory()) return false;
+        if (f.exists() && f.canWrite()) return true;
+        if (!f.exists() && f.getParentFile() != null && f.getParentFile().canWrite())
+            return true;
+        return false;
+    }
+
+    protected Component prepareFileNameRenderer(SaveLayerInfo info) {
+        lblRenderer.setIcon(null);
+        if (info.getFile() == null) {
+            if (!info.isDoSaveToFile()) {
+                lblRenderer.setText(tr("No file associated with this layer"));
+            } else {
+                lblRenderer.setBackground(new Color(255,197,197));
+                lblRenderer.setText(tr("Please select a file"));
+            }
+            lblRenderer.setFont(lblRenderer.getFont().deriveFont(Font.ITALIC));
+            lblRenderer.setToolTipText(tr("Layer ''{0}'' is not backed by a file", info.getName()));
+        } else {
+            String text = info.getFile().getName();
+            String parent = info.getFile().getParent();
+            if (parent != null) {
+                if (parent.length() <= 10) {
+                    text = info.getFile().getPath();
+                } else {
+                    text = parent.substring(0, 10) + "..." + File.separator + text;
+                }
+            }
+            lblRenderer.setText(text);
+            lblRenderer.setToolTipText(info.getFile().getAbsolutePath());
+            if (info.isDoSaveToFile() && !canWrite(info.getFile())) {
+                lblRenderer.setBackground(new Color(255,197,197));
+                lblRenderer.setToolTipText(tr("File ''{0}'' is not writable. Please enter another file name.", info.getFile().getPath()));
+            }
+        }
+        return lblRenderer;
+    }
+
+    protected Component prepareUploadRenderer(SaveLayerInfo info){
+        cbRenderer.setSelected(info.isDoUploadToServer());
+        lblRenderer.setToolTipText(tr("Select to upload layer ''{0}'' to the server ''{1}''", info.getName(), OsmApi.getOsmApi().getBaseUrl()));
+        return cbRenderer;
+    }
+
+    protected Component prepareSaveToFileRenderer(SaveLayerInfo info){
+        cbRenderer.setSelected(info.isDoSaveToFile());
+        lblRenderer.setToolTipText(tr("Select to upload layer ''{0}'' to the server ''{1}''", info.getName(), OsmApi.getOsmApi().getBaseUrl()));
+        return cbRenderer;
+    }
+
+    protected void resetRenderers() {
+        lblRenderer.setOpaque(true);
+        lblRenderer.setBackground(UIManager.getColor("Table.background"));
+        lblRenderer.setIcon(null);
+        lblRenderer.setText("");
+        lblRenderer.setFont(UIManager.getFont("Table.font"));
+        lblRenderer.setHorizontalAlignment(JLabel.LEFT);
+
+        cbRenderer.setSelected(false);
+        cbRenderer.setOpaque(true);
+        cbRenderer.setBackground(UIManager.getColor("Table.background"));
+    }
+
+    public Component getTableCellRendererComponent(JTable table, Object value, boolean isSelected,
+            boolean hasFocus, int row, int column) {
+
+        resetRenderers();
+        SaveLayerInfo info = (SaveLayerInfo)value;
+        switch(column) {
+            case 0: return prepareLayerNameRenderer(info);
+            case 1: return prepareUploadRequiredRenderer(info);
+            case 2: return prepareSaveToFileRequired(info);
+            case 3: return prepareFileNameRenderer(info);
+            case 4: return prepareUploadRenderer(info);
+            case 5: return prepareSaveToFileRenderer(info);
+        }
+        return null;
+    }
+}
Index: trunk/src/org/openstreetmap/josm/gui/io/SaveLayerTask.java
===================================================================
--- trunk/src/org/openstreetmap/josm/gui/io/SaveLayerTask.java	(revision 2025)
+++ trunk/src/org/openstreetmap/josm/gui/io/SaveLayerTask.java	(revision 2025)
@@ -0,0 +1,68 @@
+// License: GPL. For details, see LICENSE file.
+package org.openstreetmap.josm.gui.io;
+
+import static org.openstreetmap.josm.tools.I18n.tr;
+
+import org.openstreetmap.josm.actions.SaveAction;
+import org.openstreetmap.josm.gui.progress.NullProgressMonitor;
+import org.openstreetmap.josm.gui.progress.ProgressMonitor;
+
+/**
+ * SaveLayerTask saves the data managed by an {@see OsmDataLayer} to the
+ * {@see OsmDataLayer#getAssociatedFile()}.
+ * 
+ * <pre>
+ *     ExecutorService executorService = ...
+ *     SaveLayerTask task = new SaveLayerTask(layer, monitor);
+ *     Future<?> taskFuture = executorServce.submit(task)
+ *     try {
+ *        // wait for the task to complete
+ *        taskFuture.get();
+ *     } catch(Exception e) {
+ *        e.printStackTracek();
+ *     }
+ * </pre>
+ */
+class SaveLayerTask extends AbstractIOTask {
+    private SaveLayerInfo layerInfo;
+    private ProgressMonitor parentMonitor;
+
+    /**
+     * 
+     * @param layerInfo information about the layer to be saved to save. Must not be null.
+     * @param monitor the monitor. Set to {@see NullProgressMonitor#INSTANCE} if null
+     * @throws IllegalArgumentException thrown if layer is null
+     */
+    protected SaveLayerTask(SaveLayerInfo layerInfo, ProgressMonitor monitor) {
+        if (layerInfo == null)
+            throw new IllegalArgumentException(tr("parameter ''{0}'' must not be null", "layerInfo"));
+        if (monitor == null) {
+            monitor = NullProgressMonitor.INSTANCE;
+        }
+        this.layerInfo =  layerInfo;
+        this.parentMonitor = monitor;
+    }
+
+    @Override
+    public void run() {
+        try {
+            parentMonitor.subTask(tr("Saving layer to ''{0}'' ...", layerInfo.getFile().toString()));
+            layerInfo.getLayer().setAssociatedFile(layerInfo.getFile());
+            if (!new SaveAction().doSave(layerInfo.getLayer())) {
+                setFailed(true);
+                return;
+            }
+            if (!isCancelled()) {
+                layerInfo.getLayer().onPostSaveToFile();
+            }
+        } catch(Exception e) {
+            e.printStackTrace();
+            setLastException(e);
+        }
+    }
+
+    @Override
+    public void cancel() {
+        setCancelled(true);
+    }
+}
Index: trunk/src/org/openstreetmap/josm/gui/io/SaveLayersColumnModel.java
===================================================================
--- trunk/src/org/openstreetmap/josm/gui/io/SaveLayersColumnModel.java	(revision 2025)
+++ trunk/src/org/openstreetmap/josm/gui/io/SaveLayersColumnModel.java	(revision 2025)
@@ -0,0 +1,75 @@
+// License: GPL. For details, see LICENSE file.
+package org.openstreetmap.josm.gui.io;
+
+import static org.openstreetmap.josm.tools.I18n.tr;
+
+import javax.swing.table.DefaultTableColumnModel;
+import javax.swing.table.TableCellEditor;
+import javax.swing.table.TableCellRenderer;
+import javax.swing.table.TableColumn;
+
+
+class SaveLayersTableColumnModel extends DefaultTableColumnModel {
+    protected void build() {
+        TableColumn col = null;
+        TableCellRenderer renderer = new SaveLayerInfoCellRenderer();
+        TableCellEditor fileNameEditor = new FilenameCellEditor();
+        TableCellEditor saveFlagEditor = new SaveFlagCellEditor();
+
+        // column 0 - Layer
+        col = new TableColumn(0);
+        col.setHeaderValue(tr("Layer"));
+        col.setResizable(true);
+        col.setCellRenderer(renderer);
+        col.setPreferredWidth(100);
+        addColumn(col);
+
+        // column 1 - Upload required
+        col = new TableColumn(1);
+        col.setHeaderValue(tr("Should upload?"));
+        col.setResizable(true);
+        col.setCellRenderer(renderer);
+        col.setPreferredWidth(50);
+        addColumn(col);
+
+        // column 2 - Save to file required
+        col = new TableColumn(2);
+        col.setHeaderValue(tr("Should save?"));
+        col.setResizable(true);
+        col.setCellRenderer(renderer);
+        col.setPreferredWidth(50);
+        addColumn(col);
+
+        // column 3 - filename
+        col = new TableColumn(3);
+        col.setHeaderValue(tr("Filename"));
+        col.setResizable(true);
+        col.setCellRenderer(renderer);
+        col.setCellEditor(fileNameEditor);
+        col.setPreferredWidth(200);
+        addColumn(col);
+
+        // column 4 - Upload
+        col = new TableColumn(4);
+        col.setHeaderValue(tr("Upload"));
+        col.setResizable(true);
+        col.setCellRenderer(renderer);
+        col.setCellEditor(saveFlagEditor);
+        col.setPreferredWidth(30);
+        addColumn(col);
+
+        // column 5 - Save
+        col = new TableColumn(5);
+        col.setHeaderValue(tr("Save"));
+        col.setResizable(true);
+        col.setCellRenderer(renderer);
+        col.setCellEditor(saveFlagEditor);
+        col.setPreferredWidth(30);
+
+        addColumn(col);
+    }
+
+    public SaveLayersTableColumnModel() {
+        build();
+    }
+}
